/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Contents of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.43 - (hide annotations) (download)
Tue Feb 11 19:00:06 2014 UTC (5 months, 2 weeks ago) by slyfox
Branch: MAIN
Changes since 1.42: +40 -19 lines
Add support for parallel building (ghc-7.8+). Disable dynamic library stripping and respect --sysconfdir (Cabal-1.18+).

1 slyfox 1.43 # Copyright 1999-2014 Gentoo Foundation
2 kosmikus 1.1 # Distributed under the terms of the GNU General Public License v2
3 slyfox 1.43 # $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.42 2013/11/20 09:19:19 slyfox Exp $
4 vapier 1.25
5     # @ECLASS: haskell-cabal.eclass
6     # @MAINTAINER:
7     # Haskell herd <haskell@gentoo.org>
8     # @AUTHOR:
9     # Original author: Andres Loeh <kosmikus@gentoo.org>
10     # Original author: Duncan Coutts <dcoutts@gentoo.org>
11     # @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
12     # @DESCRIPTION:
13 kosmikus 1.1 # Basic instructions:
14     #
15     # Before inheriting the eclass, set CABAL_FEATURES to
16     # reflect the tools and features that the package makes
17     # use of.
18     #
19     # Currently supported features:
20     # haddock -- for documentation generation
21 kolmodin 1.21 # hscolour -- generation of colourised sources
22 slyfox 1.35 # hoogle -- generation of documentation search index
23 kosmikus 1.1 # alex -- lexer/scanner generator
24     # happy -- parser generator
25     # c2hs -- C interface generator
26     # cpphs -- C preprocessor clone written in Haskell
27     # profile -- if package supports to build profiling-enabled libraries
28     # bootstrap -- only used for the cabal package itself
29 dcoutts 1.3 # bin -- the package installs binaries
30     # lib -- the package installs libraries
31 kolmodin 1.16 # nocabaldep -- don't add dependency on cabal.
32 slyfox 1.23 # only used for packages that _must_ not pull the dependency
33     # on cabal, but still use this eclass (e.g. haskell-updater).
34 slyfox 1.32 # test-suite -- add support for cabal test-suites (introduced in Cabal-1.8)
35 kosmikus 1.1
36 slyfox 1.43 inherit eutils ghc-package multilib multiprocessing
37 kosmikus 1.1
38 slyfox 1.24 # @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
39     # @DESCRIPTION:
40     # User-specified additional parameters passed to 'setup configure'.
41 zmedico 1.39 # example: /etc/portage/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
42 slyfox 1.24 : ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
43    
44 slyfox 1.27 # @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
45     # @DESCRIPTION:
46     # User-specified additional parameters passed to 'setup build'.
47 zmedico 1.39 # example: /etc/portage/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
48 slyfox 1.27 : ${CABAL_EXTRA_BUILD_FLAGS:=}
49    
50 slyfox 1.24 # @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
51     # @DESCRIPTION:
52     # User-specified additional parameters for ghc when building
53     # _only_ 'setup' binary bootstrap.
54 zmedico 1.39 # example: /etc/portage/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
55 slyfox 1.24 # linking 'setup' faster.
56     : ${GHC_BOOTSTRAP_FLAGS:=}
57    
58 slyfox 1.36 # @ECLASS-VARIABLE: CABAL_DEBUG_LOOSENING
59     # @DESCRIPTION:
60     # Show debug output for 'cabal_chdeps' function if set.
61     # Needs working 'diff'.
62     : ${CABAL_DEBUG_LOOSENING:=}
63    
64 kolmodin 1.19 HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
65    
66     case "${EAPI:-0}" in
67 axs 1.34 2|3|4|5) HASKELL_CABAL_EXPF+=" src_configure" ;;
68 kolmodin 1.19 *) ;;
69     esac
70    
71     EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
72 kosmikus 1.1
73     for feature in ${CABAL_FEATURES}; do
74     case ${feature} in
75 kolmodin 1.16 haddock) CABAL_USE_HADDOCK=yes;;
76 kolmodin 1.21 hscolour) CABAL_USE_HSCOLOUR=yes;;
77 slyfox 1.26 hoogle) CABAL_USE_HOOGLE=yes;;
78 kolmodin 1.16 alex) CABAL_USE_ALEX=yes;;
79     happy) CABAL_USE_HAPPY=yes;;
80     c2hs) CABAL_USE_C2HS=yes;;
81     cpphs) CABAL_USE_CPPHS=yes;;
82     profile) CABAL_USE_PROFILE=yes;;
83     bootstrap) CABAL_BOOTSTRAP=yes;;
84     bin) CABAL_HAS_BINARIES=yes;;
85     lib) CABAL_HAS_LIBRARIES=yes;;
86     nocabaldep) CABAL_FROM_GHC=yes;;
87 slyfox 1.32 test-suite) CABAL_TEST_SUITE=yes;;
88 dcoutts 1.3 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";;
89 kosmikus 1.1 esac
90     done
91    
92     if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
93     IUSE="${IUSE} doc"
94 slyfox 1.28 # don't require depend on itself to build docs.
95     # ebuild bootstraps docs from just built binary
96     [[ ${CATEGORY}/${PN} = "dev-haskell/haddock" ]] || DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
97 kosmikus 1.1 fi
98    
99 kolmodin 1.21 if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
100     IUSE="${IUSE} hscolour"
101     DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
102     fi
103    
104 kosmikus 1.1 if [[ -n "${CABAL_USE_ALEX}" ]]; then
105     DEPEND="${DEPEND} dev-haskell/alex"
106     fi
107    
108     if [[ -n "${CABAL_USE_HAPPY}" ]]; then
109     DEPEND="${DEPEND} dev-haskell/happy"
110     fi
111    
112     if [[ -n "${CABAL_USE_C2HS}" ]]; then
113     DEPEND="${DEPEND} dev-haskell/c2hs"
114     fi
115    
116     if [[ -n "${CABAL_USE_CPPHS}" ]]; then
117     DEPEND="${DEPEND} dev-haskell/cpphs"
118     fi
119    
120     if [[ -n "${CABAL_USE_PROFILE}" ]]; then
121     IUSE="${IUSE} profile"
122     fi
123    
124 slyfox 1.32 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
125     IUSE="${IUSE} test"
126     fi
127    
128 kosmikus 1.1 # We always use a standalone version of Cabal, rather than the one that comes
129     # with GHC. But of course we can't depend on cabal when building cabal itself.
130 dcoutts 1.14 if [[ -z ${CABAL_MIN_VERSION} ]]; then
131     CABAL_MIN_VERSION=1.1.4
132     fi
133 kolmodin 1.16 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]]; then
134 dcoutts 1.11 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
135 kosmikus 1.1 fi
136    
137 dcoutts 1.14 # returns the version of cabal currently in use
138     _CABAL_VERSION_CACHE=""
139     cabal-version() {
140     if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
141     if [[ "${CABAL_BOOTSTRAP}" ]]; then
142     # We're bootstrapping cabal, so the cabal version is the version
143     # of this package itself.
144     _CABAL_VERSION_CACHE="${PV}"
145 kolmodin 1.17 elif [[ "${CABAL_FROM_GHC}" ]]; then
146 slyfox 1.24 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
147     # /path/to/ghc/Cabal-${VER} -> ${VER}
148     _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
149 dcoutts 1.14 else
150     # We ask portage, not ghc, so that we only pick up
151     # portage-installed cabal versions.
152     _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
153     fi
154     fi
155     echo "${_CABAL_VERSION_CACHE}"
156     }
157    
158 kosmikus 1.1 cabal-bootstrap() {
159     local setupmodule
160 dcoutts 1.14 local cabalpackage
161 kosmikus 1.1 if [[ -f "${S}/Setup.lhs" ]]; then
162     setupmodule="${S}/Setup.lhs"
163 slyfox 1.29 elif [[ -f "${S}/Setup.hs" ]]; then
164     setupmodule="${S}/Setup.hs"
165 kosmikus 1.1 else
166 slyfox 1.29 die "No Setup.lhs or Setup.hs found"
167 kosmikus 1.1 fi
168    
169 slyfox 1.31 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
170     eerror "The package dev-haskell/cabal is not correctly installed for"
171     eerror "the currently active version of ghc ($(ghc-version)). Please"
172     eerror "run haskell-updater or re-build dev-haskell/cabal."
173     die "cabal is not correctly installed"
174     fi
175    
176 kosmikus 1.1 # We build the setup program using the latest version of
177     # cabal that we have installed
178 slyfox 1.29 cabalpackage=Cabal-$(cabal-version)
179 dcoutts 1.14 einfo "Using cabal-$(cabal-version)."
180 slyfox 1.24
181     make_setup() {
182 slyfox 1.26 set -- -package "${cabalpackage}" --make "${setupmodule}" \
183 slyfox 1.24 ${GHC_BOOTSTRAP_FLAGS} \
184     "$@" \
185     -o setup
186 slyfox 1.27 echo $(ghc-getghc) ${HCFLAGS} "$@"
187 slyfox 1.26 $(ghc-getghc) "$@"
188 slyfox 1.24 }
189     if $(ghc-supports-shared-libraries); then
190 slyfox 1.30 # # some custom build systems might use external libraries,
191     # # for which we don't have shared libs, so keep static fallback
192     # bug #411789, http://hackage.haskell.org/trac/ghc/ticket/5743#comment:3
193 slyfox 1.35 # http://hackage.haskell.org/trac/ghc/ticket/7062
194     # http://hackage.haskell.org/trac/ghc/ticket/3072
195     # ghc does not set RPATH for extralibs, thus we do it ourselves by hands
196     einfo "Prepending $(ghc-libdir) to LD_LIBRARY_PATH"
197     if [[ ${CHOST} != *-darwin* ]]; then
198     LD_LIBRARY_PATH="$(ghc-libdir)${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
199     export LD_LIBRARY_PATH
200     else
201     DYLD_LIBRARY_PATH="$(ghc-libdir)${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
202     export DYLD_LIBRARY_PATH
203     fi
204     { make_setup -dynamic "$@" && ./setup --help >/dev/null; } ||
205 slyfox 1.30 make_setup "$@" || die "compiling ${setupmodule} failed"
206 slyfox 1.24 else
207     make_setup "$@" || die "compiling ${setupmodule} failed"
208     fi
209 kosmikus 1.1 }
210    
211 dcoutts 1.14 cabal-mksetup() {
212     local setupdir
213    
214     if [[ -n $1 ]]; then
215     setupdir=$1
216     else
217     setupdir=${S}
218     fi
219    
220     rm -f "${setupdir}"/Setup.{lhs,hs}
221    
222     echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
223 slyfox 1.29 > $setupdir/Setup.hs || die "failed to create default Setup.hs"
224 dcoutts 1.14 }
225    
226 kolmodin 1.21 cabal-hscolour() {
227 slyfox 1.26 set -- hscolour "$@"
228     echo ./setup "$@"
229     ./setup "$@" || die "setup hscolour failed"
230 kolmodin 1.21 }
231    
232 kosmikus 1.1 cabal-haddock() {
233 slyfox 1.26 set -- haddock "$@"
234     echo ./setup "$@"
235     ./setup "$@" || die "setup haddock failed"
236 kosmikus 1.1 }
237    
238 kolmodin 1.21 cabal-hscolour-haddock() {
239     # --hyperlink-source implies calling 'setup hscolour'
240 slyfox 1.26 set -- haddock --hyperlink-source
241     echo ./setup "$@"
242     ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
243 kolmodin 1.21 }
244    
245 slyfox 1.41 cabal-die-if-nonempty() {
246     local breakage_type=$1
247     shift
248    
249     [[ "${#@}" == 0 ]] && return 0
250     eerror "Detected ${breakage_type} packages: ${@}"
251     die "//==-- Please, run 'haskell-updater' to fix ${breakage_type} packages --==//"
252     }
253    
254 slyfox 1.40 cabal-show-brokens() {
255     # pretty-printer
256     $(ghc-getghcpkg) check 2>&1 \
257     | egrep -v '^Warning: haddock-(html|interfaces): ' \
258     | egrep -v '^Warning: include-dirs: '
259    
260 slyfox 1.41 cabal-die-if-nonempty 'broken' \
261     $($(ghc-getghcpkg) check --simple-output)
262     }
263 slyfox 1.40
264 slyfox 1.41 cabal-show-old() {
265     cabal-die-if-nonempty 'outdated' \
266     $("${EPREFIX}"/usr/sbin/haskell-updater --quiet --upgrade --list-only)
267 slyfox 1.40 }
268    
269     cabal-show-brokens-and-die() {
270     cabal-show-brokens
271 slyfox 1.41 cabal-show-old
272 slyfox 1.40
273     die "$@"
274     }
275    
276 kosmikus 1.1 cabal-configure() {
277 slyfox 1.43 local cabalconf=()
278 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
279    
280 dcoutts 1.14 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
281 slyfox 1.43 cabalconf+=(--with-haddock=${EPREFIX}/usr/bin/haddock)
282 dcoutts 1.14 fi
283 kosmikus 1.1 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
284 slyfox 1.43 cabalconf+=(--enable-library-profiling)
285 kosmikus 1.1 fi
286 slyfox 1.23 if [[ -n "${CABAL_USE_ALEX}" ]]; then
287 slyfox 1.43 cabalconf+=(--with-alex=${EPREFIX}/usr/bin/alex)
288 slyfox 1.23 fi
289    
290     if [[ -n "${CABAL_USE_HAPPY}" ]]; then
291 slyfox 1.43 cabalconf+=(--with-happy=${EPREFIX}/usr/bin/happy)
292 slyfox 1.23 fi
293    
294     if [[ -n "${CABAL_USE_C2HS}" ]]; then
295 slyfox 1.43 cabalconf+=(--with-c2hs=${EPREFIX}/usr/bin/c2hs)
296 slyfox 1.23 fi
297     if [[ -n "${CABAL_USE_CPPHS}" ]]; then
298 slyfox 1.43 cabalconf+=(--with-cpphs=${EPREFIX}/usr/bin/cpphs)
299 slyfox 1.23 fi
300 slyfox 1.32 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
301 slyfox 1.43 cabalconf+=($(use_enable test tests))
302 slyfox 1.32 fi
303 slyfox 1.23
304 slyfox 1.27 local option
305     for option in ${HCFLAGS}
306     do
307 slyfox 1.43 cabalconf+=(--ghc-option="$option")
308 slyfox 1.27 done
309    
310 slyfox 1.43 # parallel on all available cores
311     if ghc-supports-parallel-make; then
312     local max_jobs=$(makeopts_jobs)
313    
314     # limit to sort-of-sane value (same as Cabal)
315     [[ ${max_jobs} -gt 64 ]] && max_jobs=64
316    
317     cabalconf+=(--ghc-option=-j"$max_jobs")
318     fi
319    
320 dcoutts 1.6 # Building GHCi libs on ppc64 causes "TOC overflow".
321     if use ppc64; then
322 slyfox 1.43 cabalconf+=(--disable-library-for-ghci)
323 dcoutts 1.5 fi
324 kosmikus 1.1
325 slyfox 1.24 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
326     # so translate LDFLAGS to ghc parameters (without filtering)
327     local flag
328 slyfox 1.43 for flag in $LDFLAGS; do cabalconf+=(--ghc-option="-optl$flag"); done
329 slyfox 1.24
330 slyfox 1.29 # disable executable stripping for the executables, as portage will
331     # strip by itself, and pre-stripping gives a QA warning.
332     # cabal versions previous to 1.4 does not strip executables, and does
333     # not accept the flag.
334     # this fixes numerous bugs, amongst them;
335     # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
336 slyfox 1.43 cabalconf+=(--disable-executable-stripping)
337 slyfox 1.29
338 slyfox 1.43 cabalconf+=(--docdir="${EPREFIX}"/usr/share/doc/${PF})
339 slyfox 1.29 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
340     # it's better if the configure chatter is in the build logs:
341 slyfox 1.43 cabalconf+=(--verbose)
342 dcoutts 1.11
343 slyfox 1.24 # We build shared version of our Cabal where ghc ships it's shared
344     # version of it. We will link ./setup as dynamic binary againt Cabal later.
345     [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
346     $(ghc-supports-shared-libraries) && \
347 slyfox 1.43 cabalconf+=(--enable-shared)
348 slyfox 1.24
349 slyfox 1.35 if $(ghc-supports-shared-libraries); then
350     # maybe a bit lower
351 slyfox 1.40 if $(ghc-supports-dynamic-by-default); then
352 slyfox 1.43 cabalconf+=(--enable-shared)
353 slyfox 1.35 fi
354     fi
355    
356 slyfox 1.43 # --sysconfdir appeared in Cabal-1.18+
357     if ./setup configure --help | grep -q -- --sysconfdir; then
358     cabalconf+=(--sysconfdir="${EPREFIX}"/etc)
359     fi
360    
361     # appeared in Cabal-1.18+ (see '--disable-executable-stripping')
362     if ./setup configure --help | grep -q -- --disable-library-stripping; then
363     cabalconf+=(--disable-library-stripping)
364     fi
365    
366 slyfox 1.26 set -- configure \
367 slyfox 1.23 --ghc --prefix="${EPREFIX}"/usr \
368 kosmikus 1.1 --with-compiler="$(ghc-getghc)" \
369     --with-hc-pkg="$(ghc-getghcpkg)" \
370 slyfox 1.23 --prefix="${EPREFIX}"/usr \
371     --libdir="${EPREFIX}"/usr/$(get_libdir) \
372 dcoutts 1.11 --libsubdir=${P}/ghc-$(ghc-version) \
373 slyfox 1.23 --datadir="${EPREFIX}"/usr/share/ \
374 dcoutts 1.11 --datasubdir=${P}/ghc-$(ghc-version) \
375 slyfox 1.43 "${cabalconf[@]}" \
376 kosmikus 1.8 ${CABAL_CONFIGURE_FLAGS} \
377 slyfox 1.24 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
378 slyfox 1.26 "$@"
379     echo ./setup "$@"
380 slyfox 1.40 ./setup "$@" || cabal-show-brokens-and-die "setup configure failed"
381 kosmikus 1.1 }
382    
383     cabal-build() {
384 dcoutts 1.14 unset LANG LC_ALL LC_MESSAGES
385 slyfox 1.27 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
386 slyfox 1.26 echo ./setup "$@"
387     ./setup "$@" \
388 kosmikus 1.1 || die "setup build failed"
389     }
390    
391     cabal-copy() {
392 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
393    
394 slyfox 1.26 set -- copy --destdir="${D}" "$@"
395     echo ./setup "$@"
396     ./setup "$@" || die "setup copy failed"
397 kosmikus 1.1
398     # cabal is a bit eager about creating dirs,
399     # so remove them if they are empty
400 slyfox 1.23 rmdir "${ED}/usr/bin" 2> /dev/null
401 kosmikus 1.1 }
402    
403     cabal-pkg() {
404 kosmikus 1.9 # This does not actually register since we're using true instead
405 slyfox 1.29 # of ghc-pkg. So it just leaves the .conf file and we can
406 kosmikus 1.1 # register that ourselves (if it exists).
407 dcoutts 1.2
408 dcoutts 1.4 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
409 slyfox 1.29 # Newer cabal can generate a package conf for us:
410     ./setup register --gen-pkg-config="${T}/${P}.conf"
411     ghc-setup-pkg "${T}/${P}.conf"
412     ghc-install-pkg
413 kosmikus 1.1 fi
414     }
415    
416 kolmodin 1.13 # Some cabal libs are bundled along with some versions of ghc
417     # eg filepath-1.0 comes with ghc-6.6.1
418     # by putting CABAL_CORE_LIB_GHC_PV="6.6.1" in an ebuild we are declaring that
419     # when building with this version of ghc, the ebuild is a dummy that is it will
420     # install no files since the package is already included with ghc.
421     # However portage still records the dependency and we can upgrade the package
422     # to a later one that's not included with ghc.
423     # You can also put a space separated list, eg CABAL_CORE_LIB_GHC_PV="6.6 6.6.1".
424     cabal-is-dummy-lib() {
425     for version in ${CABAL_CORE_LIB_GHC_PV[*]}; do
426 slyfox 1.33 [[ "$(ghc-version)" == ${version} ]] && return 0
427 kolmodin 1.13 done
428     return 1
429     }
430    
431 kosmikus 1.1 # exported function: check if cabal is correctly installed for
432     # the currently active ghc (we cannot guarantee this with portage)
433     haskell-cabal_pkg_setup() {
434 slyfox 1.38 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
435     [[ ${RDEPEND} == *dev-lang/ghc* ]] || eqawarn "QA Notice: A library does not have runtime dependency on dev-lang/ghc."
436     fi
437 dcoutts 1.4 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
438 slyfox 1.29 eqawarn "QA Notice: Neither bin nor lib are in CABAL_FEATURES."
439 dcoutts 1.4 fi
440 dcoutts 1.3 if [[ -n "${CABAL_UNKNOWN}" ]]; then
441 slyfox 1.29 eqawarn "QA Notice: Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
442 dcoutts 1.3 fi
443 kolmodin 1.13 if cabal-is-dummy-lib; then
444     einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
445     fi
446 kosmikus 1.1 }
447    
448 kolmodin 1.19 haskell-cabal_src_configure() {
449 slyfox 1.29 cabal-is-dummy-lib && return
450    
451     pushd "${S}" > /dev/null
452 kolmodin 1.19
453 slyfox 1.29 cabal-bootstrap
454 slyfox 1.22
455 slyfox 1.29 cabal-configure "$@"
456 kolmodin 1.19
457 slyfox 1.29 popd > /dev/null
458 kolmodin 1.19 }
459    
460     # exported function: nice alias
461     cabal_src_configure() {
462     haskell-cabal_src_configure "$@"
463     }
464    
465 kosmikus 1.1 # exported function: cabal-style bootstrap configure and compile
466     cabal_src_compile() {
467 slyfox 1.24 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
468     # and forgets to separate src_compile() to src_configure()/src_compile().
469     # Such error leads to default src_configure and we lose all passed flags.
470     if ! has "${EAPI:-0}" 0 1; then
471     local passed_flag
472     for passed_flag in "$@"; do
473     [[ ${passed_flag} == --flags=* ]] && \
474 slyfox 1.29 eqawarn "QA Notice: Cabal option '${passed_flag}' has effect only in src_configure()"
475 slyfox 1.24 done
476     fi
477    
478 slyfox 1.29 cabal-is-dummy-lib && return
479    
480     has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
481     cabal-build
482 kosmikus 1.1
483 slyfox 1.29 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
484     if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
485     # hscolour and haddock
486     cabal-hscolour-haddock
487 kolmodin 1.21 else
488 slyfox 1.29 # just haddock
489     cabal-haddock
490     fi
491     else
492     if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
493     # just hscolour
494     cabal-hscolour
495 kolmodin 1.13 fi
496 kosmikus 1.1 fi
497     }
498 kolmodin 1.16
499 kosmikus 1.1 haskell-cabal_src_compile() {
500 kolmodin 1.19 pushd "${S}" > /dev/null
501    
502     cabal_src_compile "$@"
503    
504     popd > /dev/null
505     }
506    
507     haskell-cabal_src_test() {
508     pushd "${S}" > /dev/null
509    
510 kolmodin 1.20 if cabal-is-dummy-lib; then
511     einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
512     else
513     einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
514 slyfox 1.26 set -- test "$@"
515     echo ./setup "$@"
516     ./setup "$@" || die "cabal test failed"
517 kolmodin 1.20 fi
518 kolmodin 1.19
519     popd > /dev/null
520 kosmikus 1.1 }
521    
522     # exported function: cabal-style copy and register
523     cabal_src_install() {
524 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
525    
526 slyfox 1.29 if ! cabal-is-dummy-lib; then
527 kolmodin 1.13 cabal-copy
528     cabal-pkg
529 slyfox 1.29 fi
530 kosmikus 1.1
531 slyfox 1.29 # create a dummy local package conf file for haskell-updater
532     # if it does not exist (dummy libraries and binaries w/o libraries)
533     local ghc_confdir_with_prefix="$(ghc-confdir)"
534     # remove EPREFIX
535     dodir ${ghc_confdir_with_prefix#${EPREFIX}}
536     local conf_file="${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
537     [[ -e $conf_file ]] || echo '[]' > "$conf_file" || die
538 slyfox 1.33
539     # make sure installed packages do not destroy ghc's
540     # bundled packages
541     local initial_pkg_db=${ROOT}/$(ghc-libdir)/package.conf.d.initial
542     if [[ -e ${initial_pkg_db} ]]; then
543     local checked_pkg
544     for checked_pkg in $(ghc-listpkg "${conf_file}")
545     do
546     local initial_pkg
547     for initial_pkg in $(ghc-listpkg "${initial_pkg_db}"); do
548     if [[ ${checked_pkg} = ${initial_pkg} ]]; then
549     eerror "Package ${checked_pkg} is shipped with $(ghc-version)."
550     eerror "Ebuild author forgot CABAL_CORE_LIB_GHC_PV entry."
551     eerror "Found in ${initial_pkg_db}."
552     die
553     fi
554     done
555     done
556     fi
557 kosmikus 1.1 }
558 kolmodin 1.19
559 kosmikus 1.1 haskell-cabal_src_install() {
560 kolmodin 1.19 pushd "${S}" > /dev/null
561    
562 kosmikus 1.1 cabal_src_install
563 kolmodin 1.19
564     popd > /dev/null
565 kosmikus 1.1 }
566    
567 slyfox 1.38 # @FUNCTION: cabal_flag
568     # @DESCRIPTION:
569 kolmodin 1.19 # ebuild.sh:use_enable() taken as base
570     #
571     # Usage examples:
572     #
573     # CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
574     # leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
575     #
576     # CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
577     # also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
578     #
579     cabal_flag() {
580     if [[ -z "$1" ]]; then
581     echo "!!! cabal_flag() called without a parameter." >&2
582     echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
583     return 1
584     fi
585    
586     local UWORD=${2:-$1}
587    
588     if use "$1"; then
589     echo "--flags=${UWORD}"
590     else
591     echo "--flags=-${UWORD}"
592     fi
593    
594     return 0
595     }
596 slyfox 1.36
597     # @FUNCTION: cabal_chdeps
598     # @DESCRIPTION:
599     # Allows easier patching of $CABAL_FILE (${S}/${PN}.cabal by default)
600     # depends
601     #
602     # Accepts argument list as pairs of substitutions: <from-string> <to-string>...
603     #
604     # Dies on error.
605     #
606     # Usage examples:
607     #
608     # src_prepare() {
609     # cabal_chdeps \
610     # 'base >= 4.2 && < 4.6' 'base >= 4.2 && < 4.7' \
611     # 'containers ==0.4.*' 'containers >= 0.4 && < 0.6'
612     #}
613     # or
614     # src_prepare() {
615     # CABAL_FILE=${S}/${MY_PN}.cabal cabal_chdeps \
616     # 'base >= 4.2 && < 4.6' 'base >= 4.2 && < 4.7'
617     # CABAL_FILE=${S}/${MY_PN}-tools.cabal cabal_chdeps \
618     # 'base == 3.*' 'base >= 4.2 && < 4.7'
619     #}
620     #
621     cabal_chdeps() {
622     local cf=${CABAL_FILE:-${S}/${PN}.cabal}
623     local from_ss # ss - substring
624     local to_ss
625     local orig_c # c - contents
626     local new_c
627    
628     [[ -f $cf ]] || die "cabal file '$cf' does not exist"
629    
630     orig_c=$(< "$cf")
631    
632     while :; do
633     from_pat=$1
634     to_str=$2
635    
636     [[ -n ${from_pat} ]] || break
637     [[ -n ${to_str} ]] || die "'${from_str}' does not have 'to' part"
638    
639 slyfox 1.37 einfo "CHDEP: '${from_pat}' -> '${to_str}'"
640    
641 slyfox 1.36 # escape pattern-like symbols
642     from_pat=${from_pat//\*/\\*}
643     from_pat=${from_pat//\[/\\[}
644    
645     new_c=${orig_c//${from_pat}/${to_str}}
646    
647     if [[ -n $CABAL_DEBUG_LOOSENING ]]; then
648     echo "${orig_c}" >"${T}/${cf}".pre
649     echo "${new_c}" >"${T}/${cf}".post
650     diff -u "${T}/${cf}".{pre,post}
651     fi
652    
653 slyfox 1.37 [[ "${orig_c}" == "${new_c}" ]] && die "no trigger for '${from_pat}'"
654 slyfox 1.36 orig_c=${new_c}
655     shift
656     shift
657     done
658    
659     echo "${new_c}" > "$cf" ||
660     die "failed to update"
661     }
662 slyfox 1.42
663     # @FUNCTION: replace-hcflags
664     # @USAGE: <old> <new>
665     # @DESCRIPTION:
666     # Replace the <old> flag with <new> in HCFLAGS. Accepts shell globs for <old>.
667     # The implementation is picked from flag-o-matic.eclass:replace-flags()
668     replace-hcflags() {
669     [[ $# != 2 ]] && die "Usage: replace-hcflags <old flag> <new flag>"
670    
671     local f new=()
672     for f in ${HCFLAGS} ; do
673     # Note this should work with globs like -O*
674     if [[ ${f} == ${1} ]]; then
675     einfo "HCFLAGS: replacing '${f}' to '${2}'"
676     f=${2}
677     fi
678     new+=( "${f}" )
679     done
680     export HCFLAGS="${new[*]}"
681    
682     return 0
683     }

  ViewVC Help
Powered by ViewVC 1.1.20